package com.terraformersmc.terrestria.biome;

import com.terraformersmc.terraform.biome.builder.TerraformBiome;
import com.terraformersmc.terrestria.init.TerrestriaBiomes;
import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import com.terraformersmc.terrestria.init.TerrestriaFeatures;
import com.terraformersmc.terrestria.init.TerrestriaSurfaces;
import net.minecraft.class_1299;
import net.minecraft.class_1959;
import net.minecraft.class_2246;
import net.minecraft.class_3031;
import net.minecraft.class_3098;
import net.minecraft.class_3101;

import static com.terraformersmc.terraform.biome.builder.DefaultFeature.*;

public class VolcanicIslandBiomes {
	public static void register() {
		TerraformBiome.Template template = new TerraformBiome.Template(TerraformBiome.builder()
				.configureSurfaceBuilder(TerrestriaSurfaces.CLIFF, TerrestriaSurfaces.BASALT_CONFIG)
				.precipitation(class_1959.class_1963.field_9382).category(class_1959.class_1961.field_9363)
				.temperature(0.9F)
				.downfall(0.9F)
				.waterColor(0x54d3c0)
				.waterFogColor(0x24a0b0)
				.addDefaultFeatures(LAND_CARVERS, STRUCTURES, LAKES, DUNGEONS, MINEABLES, ORES, DISKS, DEFAULT_FLOWERS,
						DEFAULT_GRASS, DEFAULT_MUSHROOMS, DEFAULT_VEGETATION, SPRINGS, FROZEN_TOP_LAYER)
				.addGrassFeature(TerrestriaBlocks.INDIAN_PAINTBRUSH.method_9564(), 1)
				.addGrassFeature(TerrestriaBlocks.MONSTERAS.method_9564(), 4)
				.addGrassFeature(class_2246.field_10479.method_9564(), 1)
				.addGrassFeature(class_2246.field_10112.method_9564(), 1)
				.addStructureFeature(class_3031.field_13565)
				.addStructureFeature(class_3031.field_13547, new class_3101(0.004D, class_3098.class_3100.field_13692))
				.addDefaultSpawnEntries()
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6114, 3, 1, 4))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6073, 15, 3, 6))
				.addSpawnEntry(new class_1959.class_1964(class_1299.field_6070, 15, 1, 5))
		);

		TerrestriaBiomes.VOLCANIC_ISLAND = TerrestriaBiomes.register("volcanic_island", template.builder()
				.category(class_1959.class_1961.field_9357)
				.depth(0.1F)
				.scale(0.2F)
				.addTreeFeature(TerrestriaFeatures.JUNGLE_PALM_TREE, 5)
				.build());

		TerrestriaBiomes.VOLCANIC_ISLAND_SHORE = TerrestriaBiomes.register("volcanic_island_shore", template.builder()
				.depth(0.05F)
				.scale(0.05F)
				.addTreeFeature(TerrestriaFeatures.JUNGLE_PALM_TREE, 2)
				.build());

		TerrestriaBiomes.VOLCANIC_ISLAND_BEACH = TerrestriaBiomes.register("volcanic_island_beach", template.builder()
				.configureSurfaceBuilder(TerrestriaSurfaces.BASALT_BEACH, TerrestriaSurfaces.BASALT_CONFIG)
				.depth(0F)
				.scale(0.05F)
				.addTreeFeature(TerrestriaFeatures.JUNGLE_PALM_TREE, 2)
				.build());
	}
}
