package com.terraformersmc.terrestria.mixin;

import com.terraformersmc.terrestria.init.TerrestriaBlocks;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2944;
import net.minecraft.class_3031;
import net.minecraft.class_3746;
import net.minecraft.class_3747;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_2944.class)
public abstract class MixinAbstractTreeFeature extends class_3031 {
	// Bypasses the "no default constructor" error
	private MixinAbstractTreeFeature() {
		super(null);

		throw new UnsupportedOperationException();
	}

	@Inject(method = "isNaturalDirtOrGrass", at = @At("HEAD"), cancellable = true)
	private static void hookIsNaturalDirtOrGrass(class_3746 world, class_2338 pos, CallbackInfoReturnable<Boolean> callback) {
		if (world.method_16358(pos, state -> {
			class_2248 block = state.method_11614();
			return block == TerrestriaBlocks.BASALT_GRASS_BLOCK;
		})) {
			callback.setReturnValue(true);
		}
	}

	@Inject(method = "isDirtOrGrass", at = @At("HEAD"), cancellable = true)
	private static void hookIsDirtOrGrass(class_3746 world, class_2338 pos, CallbackInfoReturnable<Boolean> callback) {
		if (world.method_16358(pos, state -> {
			class_2248 block = state.method_11614();
			return block == TerrestriaBlocks.BASALT_GRASS_BLOCK;
		})) {
			callback.setReturnValue(true);
		}
	}

	@Inject(method = "setToDirt", at = @At("HEAD"), cancellable = true)
	private void hookSetToDirt(class_3747 world, class_2338 pos, CallbackInfo callback) {
		if (world.method_16358(pos, state -> {
			class_2248 block = state.method_11614();
			return block == TerrestriaBlocks.BASALT_GRASS_BLOCK || block == TerrestriaBlocks.BASALT_DIRT;
		})) {
			int neighborUpdatesFlag = this.field_13556 ? 1 : 0;

			world.method_8652(pos, TerrestriaBlocks.BASALT_DIRT.method_9564(), 16 | 2 | neighborUpdatesFlag);

			callback.cancel();
		}
	}

}
